# -- don't import anything here that could import Theano
#    Because theano configures itself on import.... we want to leave
#    room for the Bandit being loaded by mongo-worker to set things up
#    for itself.


from .base import STATUS_STRINGS
from .base import STATUS_NEW
from .base import STATUS_RUNNING
from .base import STATUS_SUSPENDED
from .base import STATUS_OK
from .base import STATUS_FAIL

from .base import JOB_STATES
from .base import JOB_STATE_NEW
from .base import JOB_STATE_RUNNING
from .base import JOB_STATE_DONE
from .base import JOB_STATE_ERROR

from .base import Bandit
from .base import as_bandit
from .base import BanditAlgo
from .base import Ctrl
from .base import Experiment
from .base import StopExperiment
from .base import Random
from .base import Trials
from .base import trials_from_docs

from .fmin import fmin
from .fmin import fmin_pass_expr_memo_ctrl
from .fmin import Domain
from .fmin import FMinIter
from .fmin import partial
from .fmin import space_eval

# -- syntactic sugar
import hp

# -- exceptions
import exceptions

# -- Import built-in optimization algorithms
import rand
import tpe

# -- TODO: deprecate in favour of tpe.suggest
from tpe import TreeParzenEstimator

